Bug 123918 - kernel oops when using atmel_cs module
kernel oops when using atmel_cs module
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
2
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Dave Jones
:
: 123239 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-05-21 14:02 EDT by Jørgen Wahlberg
Modified: 2015-01-04 17:06 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-04-16 01:36:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jørgen Wahlberg 2004-05-21 14:02:03 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6)
Gecko/20040515 Firefox/0.8

Description of problem:
Using Fedora Core 2 on a Dell Latitude C610 Laptop with a 3com
3CRSHPW196 WLAN PCMCIA card.

I get oops using the 3CRSHPW196 card and the Atmel firmware installed
from http://thekelleys.org.uk/atmel/atmel-firmware-1.0-1.i386.rpm

When inserting the card or doing a cardctl insert i get the following
in /var/log/messages

May 20 18:21:34 jwlaptop cardmgr[3687]: socket 1: 3Com 3CRSHPW_96
Wireless LAN PC Card
May 20 18:21:35 jwlaptop kernel: eth1: MAC address 00:04:75:f6:93:96
May 20 18:21:35 jwlaptop kernel: eth1: Atmel at76c50x wireless.
Version 0.96 simon@thekelleys.org.uk
May 20 18:21:35 jwlaptop kernel: eth1: 3com 3CRSHPW196 index 0x01: Vcc
3.3, irq 3, io 0x0100-0x011f
May 20 18:21:35 jwlaptop kernel: ip_tables: (C) 2000-2002 Netfilter
core team
May 20 18:21:35 jwlaptop kernel: Unable to handle kernel NULL pointer
dereference at virtual address 00000000
May 20 18:21:35 jwlaptop kernel:  printing eip:
May 20 18:21:35 jwlaptop kernel: 0216c0bf
May 20 18:21:35 jwlaptop kernel: *pde = 00000000
May 20 18:21:35 jwlaptop kernel: Oops: 0000 [#1]
May 20 18:21:35 jwlaptop kernel: CPU:    0
May 20 18:21:35 jwlaptop kernel: EIP:    0060:[<0216c0bf>]    Not tainted
May 20 18:21:35 jwlaptop kernel: EFLAGS: 00010286   (2.6.5-1.358) 
May 20 18:21:35 jwlaptop kernel: EIP is at object_path_length+0x10/0x25
May 20 18:21:35 jwlaptop kernel: eax: 00000000   ebx: 00000001   ecx:
ffffffff   edx: 23d966a4
May 20 18:21:35 jwlaptop kernel: esi: 00000000   edi: 00000000   ebp:
00000003   esp: 0d535e00
May 20 18:21:35 jwlaptop kernel: ds: 007b   es: 007b   ss: 0068
May 20 18:21:35 jwlaptop kernel: Process ip (pid: 4275,
threadinfo=0d535000 task=0d6008b0)
May 20 18:21:35 jwlaptop kernel: Stack: 022db0e0 022db080 0216c145
022dad28 1cb6ec80 022a8be7 23d966a4 022db0e0 
May 20 18:21:35 jwlaptop kernel:        11279110 022db080 00000000
021d9e0b 0cdc6790 022db120 0cdc67d4 11279110 
May 20 18:21:35 jwlaptop kernel:        021db8ae 23d96680 060b4228
0d535e74 022c9d44 0212e95c 00000007 0d535ec3 
May 20 18:21:35 jwlaptop kernel: Call Trace:
May 20 18:21:35 jwlaptop kernel:  [<0216c145>]
sysfs_create_link+0x28/0x117
May 20 18:21:35 jwlaptop kernel:  [<021d9e0b>] class_device_add+0xd7/0xfb
May 20 18:21:35 jwlaptop kernel:  [<021db8ae>]
fw_register_class_device+0xe5/0x120
May 20 18:21:35 jwlaptop kernel:  [<0212e95c>]
buffered_rmqueue+0x124/0x147
May 20 18:21:35 jwlaptop kernel:  [<021db907>]
fw_setup_class_device+0x1e/0x90
May 20 18:21:35 jwlaptop kernel:  [<021db9e1>] request_firmware+0x68/0x139
May 20 18:21:35 jwlaptop kernel:  [<23de1481>]
reset_atmel_card+0x105/0x535 [atmel]
May 20 18:21:35 jwlaptop kernel:  [<23dde503>] atmel_open+0xb6/0x178
[atmel]
May 20 18:21:35 jwlaptop kernel:  [<02235a97>] dev_open+0x5f/0xcc
May 20 18:21:35 jwlaptop kernel:  [<022369cc>] dev_change_flags+0x48/0xee
May 20 18:21:35 jwlaptop kernel:  [<02267a19>] devinet_ioctl+0x255/0x4a1
May 20 18:21:35 jwlaptop kernel:  [<022694a8>] inet_ioctl+0x47/0x73
May 20 18:21:35 jwlaptop kernel:  [<022301a5>] sock_ioctl+0x268/0x280
May 20 18:21:35 jwlaptop kernel:  [<0223054f>] sys_socket+0x2a/0x3d
May 20 18:21:35 jwlaptop kernel:  [<0214ea0e>] sys_ioctl+0x1f2/0x224
May 20 18:21:35 jwlaptop kernel: 
May 20 18:21:35 jwlaptop kernel: Code: f2 ae f7 d1 49 8b 52 24 8d 5c
19 01 85 d2 75 e9 89 d8 5b 5f 

I ended up using the 2.6.5-1.327 kernel from test3 which works fine
for me.



Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Install Fedora Core 2
2. install http://thekelleys.org.uk/atmel/atmel-firmware-1.0-1.i386.rpm
3. edit /etc/sysconfig/network-scripts/ifcfg-eth1
4. insert PCMCIA card

    

Actual Results:  errors in /var/log/messages, unstable system, no
network on wlan interface

Expected Results:  getting network connectivity, getting answer from
the dhcp server.

Additional info:

This works when using kernel-2.6.5-1.327 from test 3. Which also is my
current workaround.

I am not a kernel hacker, but after some googling I am pretty sure
this problem is the same as being discussed in the linux kernel
mailing list thread you can find here: http://lkml.org/lkml/2004/4/23/4
Comment 1 Tim Jackson 2004-05-24 21:12:43 EDT
This is a duplicate of bug #123239.
Comment 2 Bastien Nocera 2004-05-25 05:15:44 EDT
*** Bug 123239 has been marked as a duplicate of this bug. ***
Comment 3 Bastien Nocera 2004-05-25 05:20:00 EDT
From the duped bug:
See http://www.uwsg.iu.edu/hypermail/linux/kernel/0404.2/1604.html
And for the thread:
http://article.gmane.org/gmane.linux.kernel/200108
Comment 4 petrosyan 2004-05-26 22:44:17 EDT
The patch that solves this problem is available at
http://thekelleys.org.uk/atmel/READ-ME.linux-2.6.6  !!!
Please apply this patch to the next kernel update.

--- linux.orig/drivers/net/wireless/atmel_cs.c
+++ linux/drivers/net/wireless/atmel_cs.c
@@ -350,6 +350,9 @@ static struct {

 static struct device atmel_device = {
         .bus_id    = "pcmcia",
+    .kobj = {
+        .k_name = "atmel_cs"
+    }
 };

 static void atmel_config(dev_link_t *link)

Comment 5 petrosyan 2004-05-31 17:46:16 EDT
The latest kernel-2.6.6-1.403.i686.rpm from
http://people.redhat.com/arjanv/2.6/RPMS.kernel/ does not give oops
messages and works fine with atmel wireless card.

the only problem is that in dmesg it gives the following message:
divert: allocating divert_blk for eth1
eth1: MAC address 00:04:75:bc:54:3d
eth1: Atmel at76c50x wireless. Version 0.96 simon@thekelleys.org.uk
eth1: 3com 3CRSHPW196 index 0x01: Vcc 3.3, irq 3, io 0x0100-0x011f
Badness in kobject_get at lib/kobject.c:433
 [<0218e801>] kobject_get+0x2c/0x36
 [<0216c222>] sysfs_create_link+0x5e/0x7f
 [<021d99e7>] class_device_add+0xd7/0xfb
 [<021db4be>] fw_register_class_device+0xe5/0x120
 [<0212de98>] buffered_rmqueue+0x124/0x147
 [<021db517>] fw_setup_class_device+0x1e/0x90
 [<021db5f1>] request_firmware+0x68/0x139
 [<2289e481>] reset_atmel_card+0x105/0x535 [atmel]
 [<2289b503>] atmel_open+0xb6/0x178 [atmel]
 [<0223631b>] dev_open+0x5f/0xcc
 [<02237250>] dev_change_flags+0x48/0xee
 [<022688b5>] devinet_ioctl+0x255/0x4a1
 [<0226a344>] inet_ioctl+0x47/0x73
 [<0223098a>] sock_ioctl+0x26d/0x285
 [<02230db8>] sys_socket+0x25/0x38
 [<0214e66e>] sys_ioctl+0x1f2/0x224
 
eth1: no IPv6 routers present
Comment 6 Jørgen Wahlberg 2004-06-13 18:38:45 EDT
The current kernel (2.6.6-1.427) works great for me.
I get Badness in kobject_get in /var/log/messages as well, but I kan
live with that.
Comment 7 Kevin DeKorte 2004-06-24 12:26:15 EDT
kernel 2.6.6-1.435 will oops when I insert the card, even with the
2.6.6 patch that is recommended by the driver author.

Jun 24 10:10:08 localhost kernel: EIP:    0060:[<02132082>]    Not tainted
Jun 24 10:10:08 localhost kernel: EFLAGS: 00010006   (2.6.6-1.435mts1)
Jun 24 10:10:08 localhost kernel: EIP is at free_block+0xa7/0xbb
Jun 24 10:10:08 localhost kernel: eax: 0381a604   ebx: 0381a608   ecx:
00000049   edx: 00100100
Jun 24 10:10:08 localhost kernel: esi: 0381a5f8   edi: 0381a600   ebp:
00000001   esp: 3766ee0c
Jun 24 10:10:08 localhost kernel: ds: 007b   es: 007b   ss: 0068
Jun 24 10:10:08 localhost kernel: Process ip (pid: 2136,
threadinfo=3766e000 task=3c55ceb0)
Jun 24 10:10:08 localhost kernel: Stack: 0381a608 0381a600 0381a5f8
0381a608 0381a628 021320f0 0381a5f8 0381a5f8
Jun 24 10:10:08 localhost kernel:        42d2fcec 0381a608 00000202
02132406 42d307e4 00000000 00000000 00000000
Jun 24 10:10:08 localhost kernel:        021906ef 375e5a64 37596200
022b0498 375e5afc 0216cc55 022e0460 022e0400
Jun 24 10:10:08 localhost kernel: Call Trace:
Jun 24 10:10:08 localhost kernel:  [<021320f0>] cache_flusharray+0x5a/0x9a
Jun 24 10:10:09 localhost kernel:  [<02132406>] kfree+0x3b/0x49
Jun 24 10:10:09 localhost kernel:  [<021906ef>] kobject_cleanup+0x2c/0x60
Jun 24 10:10:09 localhost kernel:  [<0216cc55>]
sysfs_hash_and_remove+0x8c/0xad
Jun 24 10:10:09 localhost kernel:  [<021db8d0>] class_device_del+0x81/0xa2
Jun 24 10:10:09 localhost kernel:  [<021db8f9>]
class_device_unregister+0x8/0x10
Jun 24 10:10:09 localhost kernel:  [<021dd4e4>]
request_firmware+0x127/0x139
Jun 24 10:10:09 localhost kernel:  [<42d3f481>]
reset_atmel_card+0x105/0x535 [atmel]
Jun 24 10:10:09 localhost kernel:  [<42d3c503>] atmel_open+0xb6/0x178
[atmel]
Jun 24 10:10:09 localhost kernel:  [<0223832b>] dev_open+0x5f/0xcc
Jun 24 10:10:09 localhost kernel:  [<02239303>] dev_change_flags+0x48/0xee
Jun 24 10:10:09 localhost kernel:  [<0226b9c9>] devinet_ioctl+0x255/0x4a1
Jun 24 10:10:10 localhost kernel:  [<0226d458>] inet_ioctl+0x47/0x73
Jun 24 10:10:10 localhost kernel:  [<0223299a>] sock_ioctl+0x26d/0x285
Jun 24 10:10:10 localhost kernel:  [<02232dc8>] sys_socket+0x25/0x38
Jun 24 10:10:10 localhost kernel:  [<0214f7f6>] sys_ioctl+0x1f2/0x224
Jun 24 10:10:10 localhost kernel:
Jun 24 10:10:10 localhost kernel: Code: 89 1a 89 53 04 45 39 fd 0f 8c
64 ff ff ff 5b 5b 5e 5f 5d c3
Comment 8 Kevin DeKorte 2004-07-15 10:26:18 EDT
Using kernel 2.6.6-1.435.2.3 and no addtional patches the driver will
load and the card will work but I do get this error:

eth1: Atmel at76c50x wireless. Version 0.96 simon@thekelleys.org.uk
eth1: Belkin F5D6020-V2 index 0x01: Vcc 5.0, irq 3, io 0x0100-0x011f
ip_tables: (C) 2000-2002 Netfilter core team
Badness in kobject_get at lib/kobject.c:433
 [<021906cd>] kobject_get+0x2c/0x36
 [<0216d632>] sysfs_create_link+0x5e/0x7f
 [<021db82f>] class_device_add+0xd7/0xfb
 [<021dd306>] fw_register_class_device+0xe5/0x120
 [<021dd35f>] fw_setup_class_device+0x1e/0x90
 [<021dd439>] request_firmware+0x68/0x139
 [<42d10481>] reset_atmel_card+0x105/0x535 [atmel]
 [<42d0d503>] atmel_open+0xb6/0x178 [atmel]
 [<0223833f>] dev_open+0x5f/0xcc
 [<02239317>] dev_change_flags+0x48/0xee
 [<0226b9dd>] devinet_ioctl+0x255/0x4a1
 [<0226d46c>] inet_ioctl+0x47/0x73
 [<022329ae>] sock_ioctl+0x26d/0x285
 [<02232ddc>] sys_socket+0x25/0x38
 [<0214f7f6>] sys_ioctl+0x1f2/0x224


Which I believe is solved by the authors patch.
Comment 9 Dave Jones 2005-04-16 01:36:28 EDT
Fedora Core 2 has now reached end of life, and no further updates will be
provided by Red Hat.  The Fedora legacy project will be producing further kernel
updates for security problems only.

If this bug has not been fixed in the latest Fedora Core 2 update kernel, please
try to reproduce it under Fedora Core 3, and reopen if necessary, changing the
product version accordingly.

Thank you.

Note You need to log in before you can comment on or make changes to this bug.